<template>
  <v-container>
    <div>
      <h1>L'id : {{id}}</h1>
      <h1>Le Nom : {{name}}</h1>
      <h1>Le Stock: {{stock}}</h1>
      <v-img
        v-bind:src="image"
        :id="{image}"
        width="300px"
        height="300px"
      ></v-img>
      <h1>le price : {{price}}</h1>
      <v-btn
          @click="deleteProduit()"
          color="error"
      >
        Supprimer le produit</v-btn>
      <v-dialog
          v-model="displayDialog"
          max-width="600px"
          :retain-focus="false"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn
              color="warning"
              dark
              v-bind="attrs"
              v-on="on"
          >
            Modifier le Produit
          </v-btn>
        </template>
        <v-card>
          <v-form>
            <v-card-title>
              <span class="headline">Produit</span>
            </v-card-title>
            <v-card-text>
              <v-container>
                <v-row>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.name"
                        label="Nom*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.stock"
                        label="Stock*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.image"
                        label="Image*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12">
                    <v-text-field
                        v-model="dialog.price"
                        label="price*"
                        type="text"
                        required
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-container>
              <small>*L'étoile indique les champs requis</small>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                  color="blue darken-1"
                  text
                  @click="displayDialog = false"
              >
                Fermer la fenêtre
              </v-btn>
              <v-btn
                  @click="displayDialog = false; updateProduit();"
                  color="blue darken-1"
              >
                Modifier
              </v-btn>
            </v-card-actions>
          </v-form>
        </v-card>
      </v-dialog>
    </div>
  </v-container>
</template>

<script>

export default {
name: "ProduitComponent",
  props: {
    id: Number,
    name: String,
    stock: Number,
    image: String,
    price: Number
  },
  data() {
    return {
      displayDialog: false,
      dialog: {
        name: '',
        stock: '',
        image: '',
        price: ''
      }
    }
  },
  mounted() {
    this.dialog.name = this.name
    this.dialog.stock = this.stock
    this.dialog.image = this.image
    this.dialog.price = this.price
  },
  methods: {
    updateProduit() {
      this.$axios.patch(`/produit/${this.id}`, {name: this.dialog.name, stock: this.dialog.stock, image: this.dialog.image, price: this.dialog.price})
          .then(() => {
            this.$emit("updated")
          }).catch((erreur) => {
        console.log(erreur)
      })
    },

    deleteProduit() {
      this.$axios.delete(`/produit/${this.id}`)
          .then(response => {
            this.$emit("updated")
          }).catch((erreur) => {
        console.log(erreur)
      })
    }
  },
}
</script>

<style scoped>

</style>